#include <stdio.h>
#include <math.h>
#include <stddef.h>
#include <stdint.h>
#include <inttypes.h>


#define N 400
static unsigned B[N];
#define Max 50

static double analyzeResult ( unsigned* Array, size_t len )
{
	unsigned elems; /* both elems and Array[] should be unsigned for the bug to happen */
	unsigned int i;
	double t;

	elems = 0;
	for ( i = 0; i < len; i++ )
		elems += Array[i];

	t = elems;

	return t;
}


double GetAlbumGain ( void )
{
	return analyzeResult ( B, sizeof(B)/sizeof(*B) );
}

/* #define TEST2 */

int main(int argc, char** argv)
{
	unsigned int i;
	double d;

	for(i = 0; i < Max; i++)
		B[i] = Max - i;

	d = GetAlbumGain();

	printf("Sum  = %f (should be equal to 1275.0)\n", d);

#ifdef TEST2
	{
		uint64_t u64;
		u64 = d;
		printf("ui64 = 0x%" PRIx64 "\n", u64);

		u64 = d + 0.001;
		printf("ui64 = 0x%" PRIx64 "\n", u64);
	}
#endif

	return 0;
}